﻿Type=Class
Version=6
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'AutoTextSizeEditText custom view

#Event: TextChaged (Old As String, New As String)
'#DesignerProperty: Key: BooleanExample, DisplayName: Boolean Example, FieldType: Boolean, DefaultValue: True, Description: Example of a boolean property.
'#DesignerProperty: Key: IntExample, DisplayName: Int Example, FieldType: Int, DefaultValue: 10, MinRange: 0, MaxRange: 100, Description: Note that MinRange and MaxRange are optional.
'#DesignerProperty: Key: StringWithListExample, DisplayName: String With List, FieldType: String, DefaultValue: Sunday, List: Sunday|Monday|Tuesday|Wednesday|Thursday|Friday|Saturday
'#DesignerProperty: Key: StringExample, DisplayName: String Example, FieldType: String, DefaultValue: Text
'#DesignerProperty: Key: ColorExample, DisplayName: Color Example, FieldType: Color, DefaultValue: 0xFFCFDCDC, Description: You can use the built-in color picker to find the color values.

Sub Class_Globals
	Private EventName As String 'ignore
	Private CallBack As Object 'ignore
	Private mBase As Panel
	
	Private cvs As Canvas
	Private mEdt As EditText
	Private su As StringUtils
	
	Private mParent As Panel
	Private mLeft, mTop, mWidth, mHeight As Int
	Private mText As String
End Sub

Public Sub Initialize (vCallback As Object, vEventName As String)
	EventName = vEventName
	CallBack = vCallback
End Sub

Public Sub DesignerCreateView (Base As Panel, Lbl As Label, Props As Map)
	mBase = Base
	mLeft = mBase.Left
	mTop = mBase.Top
	mWidth = mBase.Width
	mHeight = mBase.Height
	mText = Lbl.Text
	
	Init
End Sub
'Adds an AutoTextSizeEditText custom view onto the given Parent view
'Parent = parent object, an Activity or a Panel
'Left, Top, Width, Height position and dimension of the AutoTextSizeEditText
'Text = text to display
Public Sub AddToParent(Parent As Panel, Left As Int, Top As Int, Width As Int, Height As Int, Text As String)
	mParent = Parent
	mLeft = Left
	mTop = Top
	mWidth = Width
	mHeight = Height
	mText = Text
	
	mBase.Initialize("")
	mParent.AddView(mBase, mLeft, mTop, mWidth, mHeight)

	Init		
End Sub

Private Sub Init
	Private bmp As Bitmap
	bmp.InitializeMutable(1, 1) 'ignore
	cvs.Initialize2(bmp)

	Private cdw As ColorDrawable
	cdw.Initialize(Colors.Transparent, 0)
	mBase.Background = cdw
		
	mEdt.Initialize("mEdt")
	mEdt.Text = mText
	mBase.AddView(mEdt, 0, 0, mWidth, mHeight)

	setText(mEdt.Text)	
End Sub

Public Sub GetBase As Panel
	Return mBase
End Sub

'Sets, gets the text
Public Sub setText(value As String)
	mEdt.Text = value
	Dim multipleLines As Boolean = mEdt.Text.Contains(CRLF)
	Dim size As Float
	For size = 2 To 80
		If CheckSize(size, multipleLines) Then Exit
	Next
	size = size - 0.5
	If CheckSize(size, multipleLines) Then size = size - 0.5
	mEdt.TextSize = size
End Sub

Public Sub getText As String
	Return mEdt.Text
End Sub

'returns true if the size is too large
Private Sub CheckSize(size As Float, MultipleLines As Boolean) As Boolean
	mEdt.TextSize = size
	If MultipleLines Then
		Return su.MeasureMultilineTextHeight(mEdt, mEdt.Text) > mEdt.Height
	Else
		Return cvs.MeasureStringWidth(mEdt.Text, mEdt.Typeface, size) > mEdt.Width Or _
			su.MeasureMultilineTextHeight(mEdt, mEdt.Text) > mEdt.Height
	End If
End Sub

Private Sub mEdt_TextChanged (Old As String, New As String)
	Dim multipleLines As Boolean = mEdt.Text.Contains(CRLF)
	Dim size As Float
	For size = 2 To 80
		If CheckSize(size, multipleLines) Then Exit
	Next
	size = size - 0.5
	If CheckSize(size, multipleLines) Then size = size - 0.5
	mEdt.TextSize = size
	
	If SubExists(CallBack, EventName & "_TextChanged") Then
		CallSub3(CallBack, EventName & "_TextChanged", Old, New)
	End If
End Sub

'Sets, gets the Left property
Public Sub setLeft(Left As Int)
	mLeft = Left
	mBase.Left = Left
End Sub

Public Sub getLeft As Int
	Return mLeft
End Sub

'Sets, gets the Top property
Public Sub setTop(Top As Int)
	mTop = Top
	mBase.Top = Top
End Sub

Public Sub getTop As Int
	Return mTop
End Sub

'Sets, gets the Width property
Public Sub setWidth(Width As Int)
	mWidth = Width
	mBase.Width = Width
	setText(mEdt.Text)
End Sub

Public Sub getWidth As Int
	Return mWidth
End Sub

'Sets, gets the Height property
Public Sub setHeight(Height As Int)
	mHeight = Height
	mBase.Height = Height
	setText(mEdt.Text)
End Sub

Public Sub getHeight As Int
	Return mHeight
End Sub
